unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, uLemmingsGame, GLHelper, AppEvnts, uResources;

type
  TfmGame = class(TForm)
    AppEvents: TApplicationEvents;
    procedure FormCreate(Sender: TObject);
    procedure AppEventsIdle(Sender: TObject; var Done: Boolean);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    World:TLemmingsWorld;
    timer,frames,lastframe:DWORD;
  public
    { Public-Deklarationen }
  end;

var
  fmGame: TfmGame;

implementation

{$R *.dfm}

const Target_FPS = 30;


procedure TfmGame.FormCreate(Sender: TObject);
begin
  World:= TLemmingsWorld.Create;
  World.RenderInit(Self);

  timer:= GetTickCount;
  Frames:= 0;
end;


procedure TfmGame.AppEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  Done:= false;
  if GetTickCount-LastFrame<1000 div Target_FPS then exit;
  World.HandleKeys;
  World.Render;
  inc(frames);
  if GetTickCount-Timer>250 then begin
    Caption:= format(SCaptionFormat,[frames/(GetTickCount-Timer)*1000]);
    timer:= GetTickCount;
    Frames:= 0;
  end;
  lastframe:= GetTickCount;
end;


procedure TfmGame.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  World.HandleMouseClick(World.ClientToScreen(Point(x,y)));
end;

end.
